Option Explicit

'----------------------------------------------------------------------
'Restores the original Task Manager.
'This is an undo script for replace_taskmgr.vbs
'----------------------------------------------------------------------

If WScript.Arguments.length = 0 Then
   Dim objShell: Set objShell = CreateObject("Shell.Application")
   objShell.ShellExecute "wscript.exe", Chr(34) & _
   WScript.ScriptFullName & Chr(34) & " uac", "", "runas", 1
Else
   Dim WshShell: Set WshShell = CreateObject("WScript.Shell")
   Dim FSO: Set FSO = CreateObject ("Scripting.FileSystemObject")
   Dim sProgDir, sErr, sReg, objFile, objFolder
   sProgDir = WshShell.ExpandEnvironmentStrings("%PROGRAMFILES%")
   sProgDir = sProgDir & "\Classic Apps\Task Manager"
   
   If FSO.FolderExists(sProgDir) Then Deltree sProgDir
   
   sReg = "HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion\" & _
   "Image File Execution Options\taskmgr.exe\Debugger"
   
   'Remove Taskmgr.exe IFEO registry entry
   On Error Resume Next
   WshShell.RegDelete sReg
   sErr = Err.number
   On Error GoTo 0
   
   If sErr = 0 Or sErr = -2147024894 Then
      WScript.Echo "SUCCESS. The original Task Manager is restored."
   Else
      WScript.Echo "Error: " & Hex(Err.number) & " when writing to the registry."
   End If
   
   Set WshShell = Nothing
   Set FSO = Nothing
End If

Sub Deltree (ByVal sProgDir)
   With FSO.GetFolder(sProgDir)
      For Each objFile In .Files
         objFile.Delete
      Next
      
      For Each objFolder In .SubFolders
         Deltree objFolder.Path
      Next
      
      If .Files.Count = 0 Then If .SubFolders.Count = 0 Then .Delete
   End With
End Sub
Set objShell = Nothing